From dda9331d0ae5990ad8022876c3540398bdb5b004 Mon Sep 17 00:00:00 2001
From: Eskil Abrahamsen Blomfeldt <eskil.abrahamsen-blomfeldt@qt.io>
Date: Wed, 19 May 2021 09:48:41 +0200
Subject: [PATCH 194/262] Fix memory leak when using small caps font
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

The small caps version of a font is kept as a QFontPrivate*
which is manually reference counted, but we neglected to
actually delete it when the reference count went to 0.

[ChangeLog][Fonts] Fixed a memory leak when initializing
a small caps font.

Fixes: QTBUG-93068
Pick-to: 6.1 5.15
Change-Id: Icc7fb7a59bf523da84d2e6fa026940a7d1230525
Reviewed-by: Konstantin Ritt <ritt.ks@gmail.com>
Reviewed-by: Robert Löhning <robert.loehning@qt.io>
(cherry picked from commit 11a40defff51dae2476e0da9f2b995a3a0f3bda8)
---
 src/gui/text/qfont.cpp | 12 ++++++++----
 1 file changed, 8 insertions(+), 4 deletions(-)

diff --git a/src/gui/text/qfont.cpp b/src/gui/text/qfont.cpp
index 94020dc665..d792d43dd7 100644
--- a/src/gui/text/qfont.cpp
+++ b/src/gui/text/qfont.cpp
@@ -220,8 +220,10 @@ QFontPrivate::~QFontPrivate()
     if (engineData && !engineData->ref.deref())
         delete engineData;
     engineData = nullptr;
-    if (scFont && scFont != this)
-        scFont->ref.deref();
+    if (scFont && scFont != this) {
+        if (!scFont->ref.deref())
+            delete scFont;
+    }
     scFont = nullptr;
 }
 
@@ -630,8 +632,10 @@ void QFont::detach()
         if (d->engineData && !d->engineData->ref.deref())
             delete d->engineData;
         d->engineData = nullptr;
-        if (d->scFont && d->scFont != d.data())
-            d->scFont->ref.deref();
+        if (d->scFont && d->scFont != d.data()) {
+            if (!d->scFont->ref.deref())
+                delete d->scFont;
+        }
         d->scFont = nullptr;
         return;
     }
-- 
2.33.0

